#Compile Exe
#Dim All
#Debug Error On     'catch array/pointer errors - OFF in production
#Debug Display On   'display untrapped errors   - OFF in production
#Include "Win32API.inc"
#Include "CommCtrl.inc"
#Resource "gbsnippets.pbr"     'misc icons

Type PointX
    X As Single : Y As Single : Z As Single
    Xo As Single : Yo As Single : Zo As Single
    Xp As Single : Yp As Single
    ColorG As Long : Marker As Long
End Type

Type TriangleX
    p1 As Long     : p2 As Long       : p3 As Long
    ZDepthO As Single : ColorG As Long : ZDepth As Single : DotProduct As Single
End Type

Type Polypoints
    Count As Long
    x1 As Single : y1 As Single
    x2 As Single : y2 As Single
    x3 As Single : y3 As Single
End Type

Type Equation
    Equa As String * 200
    Title As String * 200
    XMax As Single
    XMin As Single
    XStep As Single
    YMax As Single
    YMin As Single
    YStep As Single
End Type

Type CustomColors : c(15) As Long : End Type

%IDC_Graphic = 500 : %IDC_Timer = 501 : %IDC_ToolbarA = 502 : %IDC_StatusBar = 503 : %IDC_TextBox = 504
%IDC_Equation = 520 : %IDC_XMax = 521 : %IDC_XMin = 522 : %IDC_XStep = 523
%IDC_Title = 527    : %IDC_YMax = 524 : %IDC_YMin = 525 : %IDC_YStep = 526 : %IDC_ToolbarB = 528
%IDM_FileExportSTL = 800 : %IDM_FileExportTOV = 801 : %IDM_FileExit = 802

Global hDlg, hDC_Graphic, hToolBarA, hToolBarB, hLst, hPopup, hPopup2, hPopup3, hPopup4, hPopup5, hPopup6 As Dword
Global P(), POnly() As PointX, T() As TriangleX, OriginalPT, CurrentFileName As String
Global OffsetX, OffsetY, POV, Angle As Single
Global PointSize, Speed, PowerOn, RotateX, RotateY, RotateZ, DisplayType, BackFace, DepthSort As Long  'flags
Global BColor, BackColor, Gradient, CurrentEquationIndex, TextBoxStyle As Long
Global ModelType, Markers, LineColor, PointColor, TriangleColor, Projection, DataDisplay As Long
Global CustomColorList As CustomColors, Equations() As Equation
Global XHigh, XLow, YHigh, YLow, ZHigh, ZLow, THigh, TLow, NoLine, FarthestPoint As Single
Global hMenu, hMenuFile As Dword

Function PBMain()
    TextBoxStyle& = %WS_Border Or %ES_AutoVScroll Or %ES_MultiLine Or %ES_WantReturn Or %WS_VScroll
    Dialog New Pixels, 0, "gbPoints - 3D Graphics Laboratory v1.0",,, 480,350, %WS_OverlappedWindow Or %WS_ClipChildren, To hDlg
    Dialog Set Icon hDlg, "mos027"
    AddMenu : AddToolbar : AddStatusBar
    Dialog Show Modal hDlg, Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local iReturn, XDelta,YDelta As Long, quadPipelineCycle As Quad, pt As Point
   Static quadTimerCycle As Quad, SpinInWork,XLast,YLast As Long, fName As String
   Select Case Cb.Msg
      Case %WM_InitDialog
         LoadEquationList : CreateDropDownEquationList
         Settings_INI "get"
         If CurrentEquationIndex > UBound(Equations) Then CurrentEquationIndex = 0
         Select Case ModelType
            Case 1 : CreateCube
            Case 2 : CreateSphere
            Case 3 : CreateEquation
            Case 4   'open from file
                If IsFile(CurrentFileName) Then
                    LoadObjectFromFile CurrentFileName
                Else
                    ModelType = 1 : CreateSphere
                End If
         End Select
         BuildLeftSide
         ScaleToFit : ShortPipeLine : DisplayInfo
         MakeTimer
      Case %WM_Size
         ResizeDialog
      Case %WM_Destroy
         Settings_INI "save"
      Case %WM_Timer
         Tix End quadTimerCycle
         Tix quadPipelineCycle
         If PowerOn Then PipeLine(Angle)
         Tix End quadPipelineCycle
         Statusbar Set Text hDlg, %IDC_Statusbar, 3, 0, Format$(quadPipelineCycle/quadTimerCycle, "0.00%")
         Progressbar Set Pos hDlg, 700, 100 * quadPipelineCycle / quadTimerCycle
         Tix quadTimerCycle

      Case %WM_MouseWheel
         Select Case Hi(Integer,Cb.WParam)    'note the use of Integer
           Case > 0  : ChangeSize 1  : ShortPipeLine
           Case < 0  : ChangeSize -1 : ShortPipeLine
         End Select

      Case %WM_SetCursor
         'monitors the 3 basic splitter bar mouse actions, lbuttondown, mousemose, lbuttonup
         Select Case Hi(Word, Cb.LParam)
            Case %WM_LButtonDown
               If PowerOn = 0 Then                       'cannot use mouse when power is on
                  iReturn = GetDlgCtrlID (Cb.WParam)
                  If iReturn = %IDC_Graphic Then
                     SpinInWork = 1
                     GetCursorPos pt                      'pt has xy screen coordinates
                     ScreenToClient hDC_Graphic, pt       'pt now has dialog client coordinates
                     XLast = Pt.x
                     YLast = Pt.y
                  End If
               End If
            Case %WM_MouseMove
               If SpinInWork Then
                  GetCursorPos pt                      'pt has xy screen coordinates
                  ScreenToClient hDC_Graphic, pt       'pt now has dialog client coordinates
                  XDelta = XLast - Pt.x
                  YDelta = YLast - Pt.y
                  If RotateY Then RotateAboutXAxis YDelta * 0.02      : ShortPipeline
                  If RotateX Then RotateAboutYAxis XDelta * 0.02 * -1 : ShortPipeline
                  XLast = pt.x
                  YLast = pt.y
               End If
            Case %WM_LButtonUp
               SpinInWork = 0
         End Select


      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDC_Graphic
                If Cb.CtlMsg = %STN_DblClk Then ResetModel : ScaleToFit : ShortPipeLine
            Case %IDM_FileExportSTL : ExportAsSTL
            Case %IDM_FileExportTOV : ExportAsTOV
            Case %IDM_FileExit      : Dialog End hDlg

            Case 201 :  PowerOn = PowerOn Xor 1
            Case 202 :  RotateX = RotateX Xor 1
            Case 203 :  RotateY = RotateY Xor 1
            Case 204 :  RotateZ = RotateZ Xor 1

            Case 205 :  DisplayType = 1 : ShortPipeline : DisplayInfo  'points
            Case 206 :  DisplayType = 2 : ShortPipeline : DisplayInfo  'lines
            Case 207 :  DisplayType = 3 : ShortPipeline : DisplayInfo  'triangles

            Case 208 :  BackFace = BackFace Xor 1     : ShortPipeline : DisplayInfo
            Case 209 :  DepthSort = DepthSort Xor 1   : ShortPipeline : DisplayInfo
            Case 222 :  Projection = Projection Xor 1 : ShortPipeline : DisplayInfo

            Case 231 :  ModelType = 3 : NewEquation : BuildLeftSide : CreateEquation : ScaleToFit : ShortPipeLine : DisplayInfo
            Case 239 :  DeleteEquation              : BuildLeftSide : CreateEquation : ScaleToFit : ShortPipeLine : DisplayInfo
            Case 232 :  ModifyCurrentEquation       : BuildLeftSide : CreateEquation : ScaleToFit : ShortPipeLine : DisplayInfo
            Case 233 :  SaveEquationsToFile
            Case 230 :  DataDisplay = DataDisplay Xor 1
                        BuildLeftSide : ResizeDialog
            Case 234 :  DisplayHelp

            Case 215 :  Gradient = Gradient Xor 1 : DrawObject   : DisplayInfo  'Gradient
            Case 216 :  Markers = Markers Xor 1   : DrawObject   : DisplayInfo  'Marker
            Case 227 :  NoLine = NoLine Xor 1     : DrawObject   : DisplayInfo  'Marker

            Case 218 :  ResetModel : ScaleToFit : ShortPipeLine
            Case 219 :  If PowerOn = 0 Then PipeLine(Angle)

            Case 210 :  CycleModel : BuildLeftSide : ScaleToFit : ShortPipeLine : DisplayInfo
            Case 220
                fName = SelectFileToOpen
                If IsFile(fName) Then
                    ModelType = 4
                    CurrentFileName = fName
                    LoadObjectFromFile CurrentFileName
                Else
                    ModelType = 3 : CreateSphere
                End If
                ScaleToFit : ShortPipeLine : DisplayInfo
            Case 221 : ModelType = 3 : BuildLeftSide : CycleEquations : ShortPipeLine : DisplayInfo

            Case 225 : ChangeSize 1  : ShortPipeLine
            Case 226 : ChangeSize -1 : ShortPipeLine

            Case 211 :  CycleSpeed                                      : ShortPipeLine : DisplayInfo : MakeTimer
            Case 212 :  CycleAngle                                      : ShortPipeLine : DisplayInfo
            Case 213 :  CyclePointSize                                  : ShortPipeLine : DisplayInfo
            Case 214 :  CycleColors     : Graphic Color %Black, BColor  : ShortPipeline

            Case 235 :  MoveLeft  : ShortPipeLine : DisplayInfo
            Case 236 :  MoveRight : ShortPipeLine : DisplayInfo
            Case 237 :  MoveUp    : ShortPipeLine : DisplayInfo
            Case 238 :  MoveDown  : ShortPipeLine : DisplayInfo

            Case 300 :  ModelType = 1 : BuildLeftSide : CreateCube     : ScaleToFit : ShortPipeLine : DisplayInfo
            Case 301 :  ModelType = 2 : BuildLeftSide : CreateSphere   : ScaleToFit : ShortPipeLine : DisplayInfo
            Case 302 :  ModelType = 3 : BuildLeftSide : CreateEquation : ScaleToFit : ShortPipeLine : DisplayInfo
            Case 303
                If IsFile(CurrentFileName) Then
                    ModelType = 4 : BuildLeftSide
                    LoadObjectFromFile CurrentFileName
                Else
                    ModelType = 3 : BuildLeftSide : CreateSphere
                End If
                ScaleToFit : ShortPipeLine : DisplayInfo

            Case 600 To 700 : CurrentEquationIndex = Cb.Ctl - 600
                ModelType = 3 : BuildLeftSide
                CreateEquation : ScaleToFit : ShortPipeLine : DisplayInfo

            Case 400 :  Speed = 1   : DisplayInfo :  MakeTimer
            Case 401 :  Speed = 2   : DisplayInfo :  MakeTimer
            Case 402 :  Speed = 5   : DisplayInfo :  MakeTimer
            Case 403 :  Speed = 10  : DisplayInfo :  MakeTimer
            Case 404 :  Speed = 20  : DisplayInfo :  MakeTimer
            Case 405 :  Speed = 40  : DisplayInfo :  MakeTimer
            Case 406 :  Speed = 60  : DisplayInfo :  MakeTimer
            Case 407 :  Speed = 80  : DisplayInfo :  MakeTimer
            Case 408 :  Speed = 100 : DisplayInfo :  MakeTimer
            Case 409 :  Speed = 250 : DisplayInfo :  MakeTimer
            Case 410 :  Speed = 500 : DisplayInfo :  MakeTimer

            Case 420 :  Angle = 0.01 : DisplayInfo
            Case 421 :  Angle = 0.02 : DisplayInfo
            Case 422 :  Angle = 0.03 : DisplayInfo
            Case 423 :  Angle = 0.04 : DisplayInfo
            Case 424 :  Angle = 0.05 : DisplayInfo
            Case 425 :  Angle = 0.10 : DisplayInfo
            Case 426 :  Angle = 0.20 : DisplayInfo

            Case 440 :  PointSize = 1  : ShortPipeLine : DisplayInfo
            Case 441 :  PointSize = 2  : ShortPipeLine : DisplayInfo
            Case 442 :  PointSize = 3  : ShortPipeLine : DisplayInfo
            Case 443 :  PointSize = 4  : ShortPipeLine : DisplayInfo
            Case 444 :  PointSize = 5  : ShortPipeLine : DisplayInfo
            Case 445 :  PointSize = 10 : ShortPipeLine : DisplayInfo
            Case 446 :  PointSize = 25 : ShortPipeLine : DisplayInfo
            Case 447 :  PointSize = 50 : ShortPipeLine : DisplayInfo

            Case 460 :  BackColor = GetColor (BColor)  : BColor = BackColor : Graphic Color %Black, BColor : ShortPipeLine 'point
            Case 461 :  PointColor = GetColor (PointColor)        : ShortPipeLine 'point
            Case 462 :  LineColor = GetColor (LineColor)          : ShortPipeLine 'line
            Case 463 :  TriangleColor = GetColor (TriangleColor)  : ShortPipeLine 'planes


         End Select
      Case %WM_Notify
         Local nmtb As TBNOTIFY Ptr, rc As RECT
         nmtb = Cb.LParam
         Select Case @nmtb.hdr.Code
             Case %TBN_DROPDOWN
                 Select Case @nmtb.iItem
                     Case 210
                         SendMessage(hToolbarA, %TB_GETRECT, 210, VarPtr(rc))
                         MapWindowPoints(hToolbarA, %HWND_Desktop, ByVal VarPtr(rc), 2)
                         TrackPopupMenu (hPopUp, 0, rc.nLeft, rc.nBottom, 0, hDlg, ByVal %NULL)
                     Case 211
                         SendMessage(hToolbarB, %TB_GETRECT, 211, VarPtr(rc))
                         MapWindowPoints(hToolbarB, %HWND_Desktop, ByVal VarPtr(rc), 2)
                         TrackPopupMenu (hPopUp2, 0, rc.nLeft, rc.nBottom, 0, hDlg, ByVal %NULL)
                     Case 212
                         SendMessage(hToolbarB, %TB_GETRECT, 212, VarPtr(rc))
                         MapWindowPoints(hToolbarB, %HWND_Desktop, ByVal VarPtr(rc), 2)
                         TrackPopupMenu (hPopUp3, 0, rc.nLeft, rc.nBottom, 0, hDlg, ByVal %NULL)
                     Case 213
                         SendMessage(hToolbarB, %TB_GETRECT, 213, VarPtr(rc))
                         MapWindowPoints(hToolbarB, %HWND_Desktop, ByVal VarPtr(rc), 2)
                         TrackPopupMenu (hPopUp4, 0, rc.nLeft, rc.nBottom, 0, hDlg, ByVal %NULL)
                     Case 214
                         SendMessage(hToolbarB, %TB_GETRECT, 214, VarPtr(rc))
                         MapWindowPoints(hToolbarB, %HWND_Desktop, ByVal VarPtr(rc), 2)
                         TrackPopupMenu (hPopUp5, 0, rc.nLeft, rc.nBottom, 0, hDlg, ByVal %NULL)
                     Case 221
                         SendMessage(hToolbarA, %TB_GETRECT, 221, VarPtr(rc))
                         MapWindowPoints(hToolbarA, %HWND_Desktop, ByVal VarPtr(rc), 2)
                         TrackPopupMenu (hPopUp6, 0, rc.nLeft, rc.nBottom, 0, hDlg, ByVal %NULL)
                 End Select
         End Select
         If Cb.NmCode = %TTN_GetDispInfo Then
            Local TT As TOOLTIPTEXT Ptr
               TT = Cb.LParam
               Select Case Cb.NmId          'or this:   @P.hdr.idFrom
                  Case 201 : @TT.@lpszText = "Automatic Rotation"
                  Case 202 : @TT.@lpszText = "Spin Around X Axis"
                  Case 203 : @TT.@lpszText = "Spin Around Y Axis"
                  Case 204 : @TT.@lpszText = "Spin Around Z Axis"
                  Case 218 : @TT.@lpszText = "Reset Model to Initial Position"
                  Case 219 : @TT.@lpszText = "Step Through a Single Rotation Cycle"
                  Case 205 : @TT.@lpszText = "Display Points Only"
                  Case 206 : @TT.@lpszText = "Display Lines Only"
                  Case 207 : @TT.@lpszText = "Display Surfaces Only"
                  Case 210 : @TT.@lpszText = "Select Model To Display"
                  Case 220 : @TT.@lpszText = "Select File To Display"
                  Case 221 : @TT.@lpszText = "Select Equation To Display"
                  Case 231 : @TT.@lpszText = "New Equation"
                  Case 239 : @TT.@lpszText = "Delete Current Equation"
                  Case 232 : @TT.@lpszText = "Update Equation With Edits"
                  Case 233 : @TT.@lpszText = "Save All Equation Changes"
                  Case 208 : @TT.@lpszText = "Implement Backface Culling"
                  Case 209 : @TT.@lpszText = "Implement Depth Sorting"
                  Case 222 : @TT.@lpszText = "Implement POV Projection"
                  Case 215 : @TT.@lpszText = "Use Gradient Colors"
                  Case 216 : @TT.@lpszText = "Display Markers (Point Mode Only)"
                  Case 211 : @TT.@lpszText = "Cycle Through/Select Timer Period"
                  Case 212 : @TT.@lpszText = "Cycle Through/Select Rotation Angle"
                  Case 213 : @TT.@lpszText = "Cycle Through/Select Point Size"
                  Case 214 : @TT.@lpszText = "Cycle Through/Select Colors"
                  Case 234 : @TT.@lpszText = "Display Operating Instructions"
                  Case 225 : @TT.@lpszText = "Zoom In (temporary)"
                  Case 226 : @TT.@lpszText = "Zoom Out (temporary)"
                  Case 235 : @TT.@lpszText = "Move the Model Left (temporary)"
                  Case 236 : @TT.@lpszText = "Move the Model Right (temporary)"
                  Case 237 : @TT.@lpszText = "Move the Model Up (temporary)"
                  Case 238 : @TT.@lpszText = "Move the Model Down (temporary)"
                  Case 230 : @TT.@lpszText = "Display Model Data"
                  Case 227 : @TT.@lpszText = "Hide Lines When Dislaying Surfaces"
               End Select
         End If

   End Select
End Function

Sub ResizeDialog
   If IsIconic(hDlg) Then Exit Sub
   Local w,h As Long
   SendMessage(hDlg, %WM_SETREDRAW, 0, 0)  'Turn off redraw for faster and smoother action
   Dialog Get Client hDlg To w,h
   Control Kill hdlg, %IDC_Graphic
   If DataDisplay Then
      'controls visible on left
      Control Add Graphic, hDlg, %IDC_Graphic, "", 195,90,w-205,h-120, %WS_Border Or %SS_Notify
      OffsetX = (w-205)/2  :  OffsetY = (h-120)/2
      Control Handle hDlg, %IDC_Graphic To hDC_Graphic
      If ModelType = 3 Then
         Control Set Size hDlg, %IDC_TextBox, 175,h-240      'Equation controls are visible
      Else
          Control Set Size hDlg, %IDC_TextBox, 175,h-140      'Equation controls are not visible
      End If
   Else
      'graphic control only
      Control Add Graphic, hDlg, %IDC_Graphic, "", 10,90,w-20,h-120, %WS_Border Or %SS_Notify
      OffsetX = (w-20)/2  :  OffsetY = (h-120)/2
      Control Handle hDlg, %IDC_Graphic To hDC_Graphic
   End If

   Graphic Attach hDlg, %IDC_Graphic, ReDraw
   Graphic Color %Black, BColor
   ScaleToFit
   ShortPipeline
   SendMessage hDlg, %WM_SETREDRAW, 1, 0   'Turn on redraw again and refresh
   Dialog ReDraw hDlg
   Graphic ReDraw
   DisplayInfo
End Sub

Sub PipeLine(Ang As Single)
    Local i As Long
    If RotateX Then RotateAboutXAxis(Ang)
    If RotateY Then RotateAboutYAxis(Ang)
    If RotateZ Then RotateAboutZAxis(Ang)
    If DepthSort = 1 Then
       If DisplayType = 1 Then SortPointsByZDepth
       If DisplayType = 2 Then SortTrianglesByZDepth
       If DisplayType = 3 Then SortTrianglesByZDepth
    ElseIf DisplayType = 1 Then
       For i = 1 To UBound(P) : POnly(i) = P(i) : Next i
    End If
    If BackFace = 1 And DisplayType = 3 Then BackFaceCulling
    ProjectToScreen
    DrawObject
End Sub

Sub ShortPipeLine
    Local i As Long
    Graphic Clear
    If DepthSort = 1 Then
       If DisplayType = 1 Then SortPointsByZDepth
       If DisplayType = 2 Then SortTrianglesByZDepth
       If DisplayType = 3 Then SortTrianglesByZDepth
    ElseIf DisplayType = 1 Then
       For i = 1 To UBound(P) : POnly(i) = P(i) : Next i
    End If
    If BackFace = 1 And DisplayType = 3 Then BackFaceCulling
    ProjectToScreen
    DrawObject
    Graphic ReDraw
End Sub

Sub RotateAboutXAxis(Ang As Single)
   Local i As Long, NewY, NewZ As Single
   For i = 1 To UBound(P)
      NewY = P(i).Y * Cos(Ang) - P(i).Z * Sin(Ang)    'X rotation
      NewZ = P(i).Y * Sin(Ang) + P(i).Z * Cos(Ang)    'X rotation
      P(i).Y = NewY : P(i).Z = NewZ
   Next i
End Sub

Sub RotateAboutYAxis(Ang As Single)
   Local i As Long, NewX, NewZ As Single
   For i = 1 To UBound(P)
      NewX = P(i).Z * Sin(Ang) + P(i).X * Cos(Ang)    'Y rotation
      NewZ = P(i).Z * Cos(Ang) - P(i).X * Sin(Ang)    'Y rotation
      P(i).X = NewX : P(i).Z = NewZ
   Next I
End Sub

Sub RotateAboutZAxis(Ang As Single)
   Local i As Long, NewX, NewY As Single
   For i = 1 To UBound(P)
      NewX = P(i).X * Cos(Ang) - P(i).Y * Sin(Ang)    'Z rotation
      NewY = P(i).X * Sin(Ang) + P(i).Y * Cos(Ang)    'Z rotation
      P(i).X = NewX : P(i).Y = NewY
   Next i
End Sub

Sub SortPointsByZDepth
   Local i As Long
   For i = 1 To UBound(P) : POnly(i) = P(i) : Next i
   Array Sort POnly(1), Using CustomPointSort          'sort POnly
End Sub

Function CustomPointSort(R As PointX, S As PointX) As Long
   'sorts in ascending order by .z element
   If R.z < S.z Then Function = -1 : Exit Function
   If R.z > S.z Then Function = +1 : Exit Function
End Function

Sub SortTrianglesByZDepth
   Local i As Long
   If UBound(T) > 0 Then
      For i = 1 To UBound(T)
         T(i).ZDepth = (P(T(i).p1).Z + P(T(i).p2).Z + P(T(i).p3).Z) / 3
      Next i
      Array Sort T(1), Using CustomTriangleSort
   End If
End Sub

Function CustomTriangleSort(R As TriangleX, S As TriangleX) As Long
   'sorts in ascending order by .ZDepth element
   If R.ZDepth < S.ZDepth Then Function = -1 : Exit Function
   If R.ZDepth > S.ZDepth Then Function = +1 : Exit Function
End Function

Function BackFaceCulling() As Long
    Dim i As Long
    'use CrossProduct to find normal with (0,0,POV), put in P(0)
    'get DotProduct between point of view and normal
    If UBound(T) > 0 Then
       For i = 1 To UBound(T)
          ComputeCrossProduct i
          T(i).DotProduct = ComputeDotProduct
       Next i
    End If
End Function

Sub ComputeCrossProduct(i As Long)
    Dim x1 As Single, y1 As Single, z1 As Single, x2 As Single, y2 As Single, z2 As Single
    'cross product defines a vector perpendicular to the triangle surface
    'uses right-hand rule of thumb rule, sequence of points defines the surface (counter-clockwise)
    'create position vectors to use in cross product
    'this code uses points P1P2 and P2P3 line segments
    'any 2 line segements from the triangle will do
    x1 = P(T(i).p2).X - P(T(i).p1).X    'position vector, x component
    y1 = P(T(i).p2).Y - P(T(i).p1).Y    'position vector, y component
    z1 = P(T(i).p2).Z - P(T(i).p1).Z    'position vector, z component

    x2 = P(T(i).p3).X - P(T(i).p1).X    'position vector, x component
    y2 = P(T(i).p3).Y - P(T(i).p1).Y    'position vector, y component
    z2 = P(T(i).p3).Z - P(T(i).p1).Z    'position vector, z component

    'put resulting cross product vector in P(0) - just a conveniently unused position in the array
    P(0).X = y1 * z2 - y2 * z1     'cross product vector, x component
    P(0).Y = x2 * z1 - x1 * z2     'cross product vector, y component
    P(0).Z = x1 * y2 - x2 * y1     'cross product vector, z component
End Sub

Function ComputeDotProduct() As Long
    'uses POV vector 0,0,POV  as x1,y1,z1
    'used cross product that was stored in P(0) as x2, y2, z2
    ComputeDotProduct = 0 * P(0).X + 0 * P(0).Y + POV * P(0).Z
End Function

Function ProjectToScreen() As Long
   Local i As Long
   If Projection Then
      'use POV to set xp/yp values
      For i = 1 To UBound(P)
         If DisplayType = 1 Then
            POnly(i).xp = POnly(i).x
            POnly(i).yp = POnly(i).y
         Else
            P(i).xp = P(i).x
            P(i).yp = P(i).y
         End If
      Next i
   Else
      'do NOT use POV to set xp/yp values
      For i = 1 To UBound(P)
         If DisplayType = 1 Then
            POnly(i).xp = POnly(i).x
            POnly(i).yp = POnly(i).y
         Else
            P(i).xp = P(i).x
            P(i).yp = P(i).y
         End If
      Next i
   End If
End Function

Sub DrawObject()
   Local i,d,PColor,LColor,TColor As Long, x,y As Single, PTS As PolyPoints
   PTS.Count = 3
   Graphic Clear
   Select Case DisplayType
       Case 1     'points
          For i = 1 To UBound(POnly)
             If Gradient Then PColor = POnly(i).ColorG Else PColor = PointColor
             x = POnly(i).xp + OffsetX  : y = POnly(i).yp + OffsetY
             If Markers Then
                Select Case POnly(i).marker
                   Case -1    : d = PointSize + 4  : Graphic Ellipse (x-d,y-d)-(x+d,y+d), %Red, %Red, 0
                   Case 1     : d = PointSize + 12 : Graphic Ellipse (x-d,y-d)-(x+d,y+d), %Green, %Green, 0
                   Case Else  : Graphic Ellipse (x-PointSize,y-Pointsize)-(x+Pointsize,y+Pointsize), PColor, PColor, 0
                End Select
             Else
                Graphic Ellipse (x-PointSize,y-Pointsize)-(x+Pointsize,y+Pointsize), PColor, PColor, 0
             End If
          Next i
       Case 2
          If UBound(T) > 0 Then
             For i = 1 To UBound(T)
                PTS.x1 = P(T(i).p1).xp + OffsetX : PTS.y1 = P(T(i).p1).yp + OffsetY
                PTS.x2 = P(T(i).p2).xp + OffsetX : PTS.y2 = P(T(i).p2).yp + OffsetY
                PTS.x3 = P(T(i).p3).xp + OffsetX : PTS.y3 = P(T(i).p3).yp + OffsetY
                Graphic Polygon PTS, LineColor, -2, 0, 0              'Graphic Polyline PTS, LineColor
             Next i
          End If
       Case 3
          If UBound(T) > 0 Then
             For i = 1 To UBound(T)
                If Gradient Then TColor = T(i).ColorG Else TColor = TriangleColor
                If NoLine Then LColor = TColor Else LColor = LineColor
                PTS.x1 = P(T(i).p1).xp + OffsetX : PTS.y1 = P(T(i).p1).yp + OffsetY
                PTS.x2 = P(T(i).p2).xp + OffsetX : PTS.y2 = P(T(i).p2).yp + OffsetY
                PTS.x3 = P(T(i).p3).xp + OffsetX : PTS.y3 = P(T(i).p3).yp + OffsetY
                If (BackFace = 1 And T(i).DotProduct > 0 ) Or BackFace = 0 Then
                   Graphic Polygon PTS, LColor, TColor, 0, 0
                End If
             Next i
          End If
   End Select
   Graphic ReDraw
End Sub

Sub LoadObjectFromFile (fName As String)
    MousePtr 11
    Select Case LCase$(Trim$(PathName$(Extn, fName), "."))
        Case "tov"  : LoadTOVFile(fName)
        Case "stla" : LoadSTLAFile(fName)
        Case "stlb" : LoadSTLBFile(fName)
    End Select
    MousePtr 0
End Sub

Sub LoadSTLBFile (fName As String)
   Local temp As String * 80
   Local x,y,z As Single
   Local i, iPoints As Long
   Local iCount As Dword
   Local iSkip As Integer

   Open fName For Binary As #1
   Get #1, , temp
   Get #1, , iCount
   ReDim P(iCount*3), POnly(iCount*3), T(iCount)

   For i = 1 To iCount
       Get #1, , x : Get #1, , y : Get #1, , z  'discard

       Incr iPoints
       Get #1, , P(iPoints).x : Get #1, , P(iPoints).y : Get #1, , P(iPoints).z
       T(i).p1 = iPoints

       Incr iPoints
       Get #1, , P(iPoints).x : Get #1, , P(iPoints).y : Get #1, , P(iPoints).z
       T(i).p2 = iPoints

       Incr iPoints
       Get #1, , P(iPoints).x : Get #1, , P(iPoints).y : Get #1, , P(iPoints).z
       T(i).p3 = iPoints

       Get #1, , iSkip
   Next i
   Close #1
   For i = 1 To UBound(P)
      P(i).xo = P(i).x : POnly(i).x = P(i).x
      P(i).yo = P(i).y : POnly(i).y = P(i).y
      P(i).zo = P(i).z : POnly(i).z = P(i).z
   Next i
   P(1).Marker = -1 : P(UBound(P)).Marker = 1
   SetPointGradientColors
   SetTriangleGradientColors
   CreateOriginalPTString
End Sub

Sub LoadSTLAFile (fName As String)

    Local temp As String, i, iCount, iPoints, iTriangles As Long

    'verify file is right type
    Open fName For Input As #1
    Line Input #1, temp
    Close #1
    If Left$(LCase$(Trim$(temp)),5) <> "solid" Then Exit Sub

    'get count # Points and # triangles
    Open fName For Binary As #1
    Get$ #1, Lof(1), temp
    Close #1
    iCount = ParseCount(LCase$(temp), "endfacet") - 1
    ReDim P(iCount*3), POnly(iCount*3), T(iCount)

    'load into P(), POnly(), T()
    Open fName For Input As #1
    Line Input #1, temp    'header, discard
    For i = 1 To iCount
        Incr iTriangles

        Line Input #1, temp 'discard
        Line Input #1, temp 'discard

        Line Input #1, temp 'p1
           temp = Trim$(temp)
           Incr iPoints
           While InStr(temp, "  ") : Replace "  " With " " In temp : Wend   'remove extra spaces
           P(iPoints).x = Val(Parse$(temp," ",2)) : POnly(iPoints).x = P(iPoints).x
           P(iPoints).y = Val(Parse$(temp," ",3)) : POnly(iPoints).y = P(iPoints).y
           P(iPoints).z = Val(Parse$(temp," ",4)) : Ponly(iPoints).z = P(iPoints).z
           T(iTriangles).p1 = iPoints

        Line Input #1, temp 'p2
           temp = Trim$(temp)
           Incr iPoints
           While InStr(temp, "  ") : Replace "  " With " " In temp : Wend   'remove extra spaces
           P(iPoints).x = Val(Parse$(temp," ",2)) : POnly(iPoints).x = P(iPoints).x
           P(iPoints).y = Val(Parse$(temp," ",3)) : POnly(iPoints).y = P(iPoints).y
           P(iPoints).z = Val(Parse$(temp," ",4)) : Ponly(iPoints).z = P(iPoints).z
           T(iTriangles).p2 = iPoints

        Line Input #1, temp 'p3
           temp = Trim$(temp)
           Incr iPoints
           While InStr(temp, "  ") : Replace "  " With " " In temp : Wend   'remove extra spaces
           P(iPoints).x = Val(Parse$(temp," ",2)) : POnly(iPoints).x = P(iPoints).x
           P(iPoints).y = Val(Parse$(temp," ",3)) : POnly(iPoints).y = P(iPoints).y
           P(iPoints).z = Val(Parse$(temp," ",4)) : Ponly(iPoints).z = P(iPoints).z
           T(iTriangles).p3 = iPoints

        Line Input #1, temp ' discard
        Line Input #1, temp ' discard

    Next i
    Close #1

   For i = 1 To UBound(P)
      P(i).xo = P(i).x : POnly(i).x = P(i).x
      P(i).yo = P(i).y : POnly(i).y = P(i).y
      P(i).zo = P(i).z : POnly(i).z = P(i).z
   Next i
   P(1).Marker = -1 : P(UBound(P)).Marker = 1
   SetPointGradientColors
   SetTriangleGradientColors
   CreateOriginalPTString
End Sub

Sub LoadTOVFile (fName As String)
    Local temp As String, i As Long
    Open fName For Input As #1
    Line Input #1, temp
    If Left$(temp,9) <> "gb3DModel" Then Exit Sub
    Line Input #1, temp
    While InStr(temp, "  ") : Replace "  " With " " In temp : Wend   'remove extra spaces
    ReDim P(Val(Parse$(temp, " ", 1)))
    ReDim POnly(Val(Parse$(temp, " ", 1)))
    ReDim T(Val(Parse$(temp, " ", 2)))
    For i = 1 To UBound(P)
       Line Input #1, temp
       While InStr(temp, "  ") : Replace "  " With " " In temp : Wend   'remove extra spaces
       P(i).x = Val(Parse$(temp, " ", 2))
       P(i).y = Val(Parse$(temp, " ", 3))
       P(i).z = Val(Parse$(temp, " ", 4))
    Next i
    For i = 1 To UBound(T)
       Line Input #1, temp
       While InStr(temp, "  ") : Replace "  " With " " In temp : Wend   'remove extra spaces
       T(i).p1 = Val(Parse$(temp, " ", 2))
       T(i).p2 = Val(Parse$(temp, " ", 3))
       T(i).p3 = Val(Parse$(temp, " ", 4))
    Next i
    Close #1
   For i = 1 To UBound(P)
      P(i).xo = P(i).x : POnly(i).x = P(i).x
      P(i).yo = P(i).y : POnly(i).y = P(i).y
      P(i).zo = P(i).z : POnly(i).z = P(i).z
   Next i
   P(1).Marker = -1 : P(UBound(P)).Marker = 1
   SetPointGradientColors
   SetTriangleGradientColors
   CreateOriginalPTString
End Sub

Sub AddStatusBar
   Control Add Statusbar, hDlg, %IDC_Statusbar,"",0,0,0,0,%CCS_Bottom Or %SBars_SizeGrip
   Statusbar Set Parts hDlg, %IDC_StatusBar, 150, 150, 99999
End Sub

Sub AddProgressBar
   Control Add Progressbar, hDlg, 700,"", 10,90,170,15, %PBS_Smooth
   Progressbar Set Pos hDlg, 700, 0
   Control Set Color hDlg, 700, %rgb_Maroon, %rgb_Silver
End Sub

Sub AddToolbar
    'add toolbar1
    Control Add Toolbar, hDlg, %IDC_ToolbarA, "Toolbar",0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat
    Control Handle hDlg, %IDC_ToolbarA To hToolbarA
    SendMessage hToolbarA, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    'add toolbar2
    Control Add Toolbar, hDlg, %IDC_ToolbarB, "Toolbar",0,40,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %CCS_NoMoveY
    Control Handle hDlg, %IDC_ToolbarB To hToolbarB
    SendMessage hToolbarB, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    'create imagelist
    ImageList New Icon 16,16,32,3 To hLst
    ImageList Add Icon hLst, "stop"           '1
    ImageList Add Icon hLst, "x"              '2
    ImageList Add Icon hLst, "y"              '3
    ImageList Add Icon hLst, "z"              '4
    ImageList Add Icon hLst, "paint"          '5
    ImageList Add Icon hLst, "fill"           '6
    ImageList Add Icon hLst, "face"           '7
    ImageList Add Icon hLst, "grid"           '8
    ImageList Add Icon hLst, "line"           '9
    ImageList Add Icon hLst, "direction"      '10
    ImageList Add Icon hLst, "plane"          '11
    ImageList Add Icon hLst, "rocket"         '12
    ImageList Add Icon hLst, "rotate"         '13
    ImageList Add Icon hLst, "points"         '14
    ImageList Add Icon hLst, "picker"         '15
    ImageList Add Icon hLst, "sorta"          '16
    ImageList Add Icon hLst, "axis"           '17
    ImageList Add Icon hLst, "color"          '18
    ImageList Add Icon hLst, "delta"          '19
    ImageList Add Icon hLst, "eye"            '20
    ImageList Add Icon hLst, "gradient"       '21
    ImageList Add Icon hLst, "marks"          '22
    ImageList Add Icon hLst, "shimmer"        '23
    ImageList Add Icon hLst, "dots"           '24
    ImageList Add Icon hLst, "fx"             '25
    ImageList Add Icon hLst, "refresh"        '26
    ImageList Add Icon hLst, "one"            '27
    ImageList Add Icon hLst, "open"           '28
    ImageList Add Icon hLst, "fx"             '29
    ImageList Add Icon hLst, "new"            '30
    ImageList Add Icon hLst, "save"           '31
    ImageList Add Icon hLst, "point"          '32
    ImageList Add Icon hLst, "question"       '33
    ImageList Add Icon hLst, "add"            '34
    ImageList Add Icon hLst, "minus"          '35
    ImageList Add Icon hLst, "trim"           '36
    ImageList Add Icon hLst, "data"           '37
    ImageList Add Icon hLst, "lefthand"       '38
    ImageList Add Icon hLst, "righthand"      '39
    ImageList Add Icon hLst, "uphand"         '40
    ImageList Add Icon hLst, "downhand"       '41
    ImageList Add Icon hLst, "delete"         '42

    'attach imagelist
    Toolbar Set ImageList hDlg, %IDC_ToolbarA, hLst, 0
    Toolbar Set ImageList hDlg, %IDC_ToolbarB, hLst, 0

    'create buttons
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 1, 201, %TbStyle_Check, "On/Off"
    Toolbar Add Separator hDlg, %IDC_ToolbarA, 20
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 2, 202, %TbStyle_Check, "x"
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 3, 203, %TbStyle_Check, "y"
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 4, 204, %TbStyle_Check, "z"
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 26, 218, %TbStyle_Button, "Reset"
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 27, 219, %TbStyle_Button, "Step"
    Toolbar Add Separator hDlg, %IDC_ToolbarA, 20
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 8, 205, %TbStyle_Check Or %TbStyle_Group, "Points"
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 9, 206, %TbStyle_Check Or %TbStyle_Group, "Lines"
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 10, 207, %TbStyle_Check Or %TbStyle_Group, "Surfaces"
    Toolbar Add Separator hDlg, %IDC_ToolbarA, 20
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 11, 210, %TbStyle_DropDown, "Display"
    Toolbar Add Separator hDlg, %IDC_ToolbarA, 20
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 28, 220, %TbStyle_Button, "Open File"
    Toolbar Add Separator hDlg, %IDC_ToolbarA, 20
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 29, 221, %TbStyle_DropDown, "Equation"
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 30, 231, %TbStyle_Button, "New"
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 42, 239, %TbStyle_Button, "Delete"
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 32, 232, %TbStyle_Button, "Update"
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 31, 233, %TbStyle_Button, "Save"
    Toolbar Add Separator hDlg, %IDC_ToolbarA, 20
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 37, 230, %TbStyle_Check, "Data"
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 33, 234, %TbStyle_Button, "Help"

    Toolbar Add Button    hDlg, %IDC_ToolbarB, 7, 208, %TbStyle_Check, "Backface Cull"
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 16, 209, %TbStyle_Check, "Depth Sort"
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 20, 222, %TbStyle_Check, "Projection"
    Toolbar Add Separator hDlg, %IDC_ToolbarB, 20
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 21, 215, %TbStyle_Check, "Gradient"
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 22, 216, %TbStyle_Check, "Markers"
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 36, 227, %TbStyle_Check, "No Line"
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 23, 211, %TbStyle_DropDown, "Speed"
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 13, 212, %TbStyle_DropDown, "Angle"
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 24, 213, %TbStyle_DropDown, "Pt Size"
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 18, 214, %TbStyle_DropDown, "Color"
    Toolbar Add Separator hDlg, %IDC_ToolbarB, 20
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 34, 225, %TbStyle_Button, "In"
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 35, 226, %TbStyle_Button, "Out"
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 38, 235, %TbStyle_Button, "Left"
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 39, 236, %TbStyle_Button, "Right"
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 40, 237, %TbStyle_Button, "Up"
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 41, 238, %TbStyle_Button, "Down"

    Menu New PopUp To hPopup
    Menu Add String, hPopup, "Cube", 300, %MF_Enabled
    Menu Add String, hPopup, "Sphere", 301, %MF_Enabled
    Menu Add String, hPopup, "<Last Equation>", 302, %MF_Enabled
    Menu Add String, hPopup, "<Last File>", 303, %MF_Enabled

    Menu New PopUp To hPopup2
    Menu Add String, hPopup2, "1", 400, %MF_Enabled
    Menu Add String, hPopup2, "2", 401, %MF_Enabled
    Menu Add String, hPopup2, "5", 402, %MF_Enabled
    Menu Add String, hPopup2, "10", 403, %MF_Enabled
    Menu Add String, hPopup2, "20", 404, %MF_Enabled
    Menu Add String, hPopup2, "40", 405, %MF_Enabled
    Menu Add String, hPopup2, "60", 406, %MF_Enabled
    Menu Add String, hPopup2, "80", 407, %MF_Enabled
    Menu Add String, hPopup2, "100", 408, %MF_Enabled
    Menu Add String, hPopup2, "250", 409, %MF_Enabled
    Menu Add String, hPopup2, "500", 410, %MF_Enabled

    Menu New PopUp To hPopup3
    Menu Add String, hPopup3, "0.01", 420, %MF_Enabled
    Menu Add String, hPopup3, "0.02", 421, %MF_Enabled
    Menu Add String, hPopup3, "0.03", 422, %MF_Enabled
    Menu Add String, hPopup3, "0.04", 423, %MF_Enabled
    Menu Add String, hPopup3, "0.05", 424, %MF_Enabled
    Menu Add String, hPopup3, "0.10", 425, %MF_Enabled
    Menu Add String, hPopup3, "0.20", 426, %MF_Enabled

    Menu New PopUp To hPopup4
    Menu Add String, hPopup4, "1",  440, %MF_Enabled
    Menu Add String, hPopup4, "2",  441, %MF_Enabled
    Menu Add String, hPopup4, "3",  442, %MF_Enabled
    Menu Add String, hPopup4, "4",  443, %MF_Enabled
    Menu Add String, hPopup4, "5",  444, %MF_Enabled
    Menu Add String, hPopup4, "10", 445, %MF_Enabled
    Menu Add String, hPopup4, "25", 446, %MF_Enabled
    Menu Add String, hPopup4, "50", 447, %MF_Enabled

    Menu New PopUp To hPopup5
    Menu Add String, hPopup5, "Background ...",  460, %MF_Enabled
    Menu Add String, hPopup5, "Point ...",  461, %MF_Enabled
    Menu Add String, hPopup5, "Line ...",  462, %MF_Enabled
    Menu Add String, hPopup5, "Triangle ...",  463, %MF_Enabled

End Sub

Sub CreateDropdownEquationList
    Local i As Long
    Menu New PopUp To hPopup6
    For i = 0 To UBound(Equations)
       Menu Add String, hPopup6, Trim$(Equations(i).Equa), 600+i, %MF_Enabled
    Next i
End Sub

Sub MakeTimer
   KillTimer hdlg, %IDC_Timer
   SetTimer(hDlg, %IDC_Timer, Speed, %NULL)    'sends %WM_Timer to dialog callback
End Sub

Sub Settings_INI(Task$)
   Local x As Long, y As Long
   Local xResult As Asciiz*%Max_Path, yResult As Asciiz*%Max_Path
   Local temp As Asciiz*%Max_Path, INIFileName As Asciiz*%Max_Path

   'defines file name (any file name will work)
   INIFileName = EXE.Path$ + "gbpoints.ini"

   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "100", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "100", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult$), Val(yResult$)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "850", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "700", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult$), Val(yResult$)   'width/height

      Getprivateprofilestring "All", "RotateX", "1",       temp, %Max_Path, INIFileName   :   RotateX = Val(temp)
      Getprivateprofilestring "All", "RotateY", "1",       temp, %Max_Path, INIFileName   :   RotateY = Val(temp)
      Getprivateprofilestring "All", "RotateZ", "1",       temp, %Max_Path, INIFileName   :   RotateZ = Val(temp)
      Getprivateprofilestring "All", "PowerOn", "1",       temp, %Max_Path, INIFileName   :   PowerOn = Val(temp)
      Getprivateprofilestring "All", "Angle", "0.02",      temp, %Max_Path, INIFileName   :   Angle = Val(temp)
      Getprivateprofilestring "All", "DisplayType", "3",   temp, %Max_Path, INIFileName   :   DisplayType  = Val(temp)
      Getprivateprofilestring "All", "ModelType", "1",     temp, %Max_Path, INIFileName   :   ModelType  = Val(temp)
      Getprivateprofilestring "All", "DepthSort", "1",     temp, %Max_Path, INIFileName   :   DepthSort = Val(temp)
      Getprivateprofilestring "All", "BackFace", "1",      temp, %Max_Path, INIFileName   :   BackFace = Val(temp)
      Getprivateprofilestring "All", "Speed", "40",        temp, %Max_Path, INIFileName   :   Speed = Val(temp)
      Getprivateprofilestring "All", "Gradient", "0",      temp, %Max_Path, INIFileName   :   Gradient = Val(temp)
      Getprivateprofilestring "All", "BackColor", "0",     temp, %Max_Path, INIFileName  :    BackColor = Val(temp)
      Getprivateprofilestring "All", "LineColor", Str$(%Yellow),    temp, %Max_Path, INIFileName   :   LineColor = Val(temp)
      Getprivateprofilestring "All", "PointColor", Str$(%Red),      temp, %Max_Path, INIFileName   :   PointColor = Val(temp)
      Getprivateprofilestring "All", "TriangleColor", Str$(&H80),   temp, %Max_Path, INIFileName   :   TriangleColor = Val(temp)
      Getprivateprofilestring "All", "Markers", "0",                temp, %Max_Path, INIFileName   :   Markers = Val(temp)
      Getprivateprofilestring "All", "PointSize", "2",              temp, %Max_Path, INIFileName   :   PointSize = Val(temp)
      Getprivateprofilestring "All", "Projection", "0",             temp, %Max_Path, INIFileName   :   Projection = Val(temp)
      Getprivateprofilestring "All", "POV", "1000",                 temp, %Max_Path, INIFileName   :   POV = Val(temp)
      Getprivateprofilestring "All", "CurrentFileName", "",         temp, %Max_Path, INIFileName   :   CurrentFileName = temp
      Getprivateprofilestring "All", "CurrentEquationIndex", "0",   temp, %Max_Path, INIFileName   :   CurrentEquationIndex = Val(temp)
      Getprivateprofilestring "All", "NoLine", "0",                 temp, %Max_Path, INIFileName   :   NoLine = Val(temp)
      Getprivateprofilestring "All", "DataDisplay", "1",            temp, %Max_Path, INIFileName   :   DataDisplay = Val(temp)

      For x = 0 To 15
         Getprivateprofilestring "Colors", "CustomColor" + Trim$(Str$(x)), "0",  temp, %Max_Path, INIFileName   :   CustomColorList.c(x) = Val(temp)
      Next x

      'apply as needed
      Toolbar Set State hDlg, %IDC_ToolbarA, ByCmd 201, %TBState_Checked * PowerOn Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_ToolbarA, ByCmd 202, %TBState_Checked * RotateX Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_ToolbarA, ByCmd 203, %TBState_Checked * RotateY Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_ToolbarA, ByCmd 204, %TBState_Checked * RotateZ Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_ToolbarB, ByCmd 204+DisplayType, %TBState_Checked Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_ToolbarB, ByCmd 208, %TBState_Checked * BackFace Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_ToolbarB, ByCmd 209, %TBState_Checked * DepthSort Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_ToolbarB, ByCmd 222, %TBState_Checked * Projection Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_ToolbarA, ByCmd 230, %TBState_Checked * DataDisplay Or %TBState_Enabled

      Toolbar Set State hDlg, %IDC_ToolbarB, ByCmd 215, %TBState_Checked * Gradient Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_ToolbarB, ByCmd 216, %TBState_Checked * Markers Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_ToolbarB, ByCmd 227, %TBState_Checked * NoLine Or %TBState_Enabled
   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If

      temp = Str$(RotateX)      : WritePrivateProfileString "All", "RotateX", temp, INIFileName
      temp = Str$(RotateY)      : WritePrivateProfileString "All", "RotateY", temp, INIFileName
      temp = Str$(RotateZ)      : WritePrivateProfileString "All", "RotateZ", temp, INIFileName
      temp = Str$(PowerOn)      : WritePrivateProfileString "All", "PowerOn", temp, INIFileName
      temp = Str$(Angle)        : WritePrivateProfileString "All", "Angle", temp, INIFileName
      temp = Str$(DisplayType)  : WritePrivateProfileString "All", "DisplayType", temp, INIFileName
      temp = Str$(ModelType)    : WritePrivateProfileString "All", "ModelType", temp, INIFileName
      temp = Str$(DepthSort)    : WritePrivateProfileString "All", "DepthSort", temp, INIFileName
      temp = Str$(BackFace)     : WritePrivateProfileString "All", "BackFace", temp, INIFileName
      temp = Str$(Speed)        : WritePrivateProfileString "All", "Speed", temp, INIFileName
      temp = Str$(Gradient)     : WritePrivateProfileString "All", "Gradient", temp, INIFileName
      temp = Str$(BackColor)    : WritePrivateProfileString "All", "BackColor", temp, INIFileName
      temp = Str$(LineColor)    : WritePrivateProfileString "All", "LineColor", temp, INIFileName
      temp = Str$(PointColor)   : WritePrivateProfileString "All", "PointColor", temp, INIFileName
      temp = Str$(TriangleColor): WritePrivateProfileString "All", "TriangleColor", temp, INIFileName
      temp = Str$(Markers)      : WritePrivateProfileString "All", "Markers", temp, INIFileName
      temp = Str$(Pointsize)    : WritePrivateProfileString "All", "PointSize", temp, INIFileName
      temp = Str$(Projection)   : WritePrivateProfileString "All", "Projection", temp, INIFileName
      temp = Str$(POV)          : WritePrivateProfileString "All", "POV", temp, INIFileName
      temp = CurrentFileName    : WritePrivateProfileString "All", "CurrentFileName", temp, INIFileName
      temp = Str$(CurrentEquationIndex)  : WritePrivateProfileString "All", "CurrentEquationIndex", temp, INIFileName
      temp = Str$(NoLine)       : WritePrivateProfileString "All", "NoLine", temp, INIFileName
      temp = Str$(DataDisplay)  : WritePrivateProfileString "All", "DataDisplay", temp, INIFileName

      For x = 0 To 15
         temp = Str$(CustomColorList.c(x)): WritePrivateProfileString "Colors", "CustomColor" + Trim$(Str$(x)), temp, INIFileName
      Next x

   End If
End Sub

Sub SetPointHighLow()
   Local i As Long
   If UBound(p) = -1 Then
       XHigh = 0: XLow = 0: YHigh = 0: YLow = 0: ZHigh = 0: ZLow = 0
   Else
       XHigh = P(1).xo: XLow = P(1).xo
       YHigh = P(1).yo: YLow = P(1).yo
       ZHigh = P(1).zo: ZLow = P(1).zo
       For i = 2 To UBound(P)
           If P(i).xo > XHigh Then XHigh = P(i).xo
           If P(i).xo < XLow Then XLow = P(i).xo

           If P(i).yo > YHigh Then YHigh = P(i).yo
           If P(i).yo < YLow Then YLow = P(i).yo

           If P(i).zo > ZHigh Then ZHigh = P(i).zo
           If P(i).zo < ZLow Then ZLow = P(i).zo
       Next i
   End If
End Sub

Sub SetTriangleHighLow()
   Local i As Long
   If UBound(T) < 1 Then
       THigh = 0: TLow = 0
   Else
       T(1).ZDepthO = (P(T(1).p1).Z + P(T(1).p2).Z + P(T(1).p3).Z) / 3
       THigh = T(1).ZDepthO : TLow = T(1).ZdepthO
       For i = 2 To UBound(T)
           T(i).ZDepthO = (P(T(i).p1).Z + P(T(i).p2).Z + P(T(i).p3).Z) / 3
           If T(i).ZDepthO > THigh Then THigh = T(i).ZDepthO
           If T(i).ZDepthO < TLow Then TLow = T(i).ZDepthO
       Next i
   End If
End Sub

Sub ResetModel
   Local i As Long
   For i = 1 To UBound(P)
      P(i).x = P(i).xo : P(i).y = P(i).yo : P(i).z = P(i).zo
      POnly(i).x = P(i).xo : POnly(i).y = P(i).yo : POnly(i).z = P(i).zo
   Next i
End Sub

Sub ScaleToFitX
   Local i,w,h,iMax,iMin As Long, ScaleFactor As Single
   iMax = Max(XHigh,XLow,YHigh,YLow,ZHigh,ZLow)
   iMin = Min(XHigh,XLow,YHigh,YLow,ZHigh,ZLow)
   Control Get Size hDlg, %IDC_Graphic To w,h
   If h < w Then ScaleFactor = h /(iMax-iMin)/1.5 Else ScaleFactor = w/(iMax-iMin)/1.5
   For i = 1 To UBound(P)
      P(i).x = P(i).xo * ScaleFactor : POnly(i).x = P(i).x
      P(i).y = P(i).yo * ScaleFactor : POnly(i).y = P(i).y
      P(i).z = P(i).zo * ScaleFactor : POnly(i).z = P(i).z
   Next i
End Sub

Sub ScaleToFit
   Local i,w,h As Long, sTemp As Single
   Local CenterX, CenterY, CenterZ, ScaleFactor As Single

   CenterX = (XHigh + XLow)/2
   CenterY = (YHigh + YLow)/2
   CenterZ = (ZHigh + ZLow)/2

   'move all nodes to center position
   For i = 1 To UBound(P)
      P(i).x = (P(i).xo - CenterX) : POnly(i).x = P(i).x
      P(i).y = (P(i).yo - CenterY) : POnly(i).y = P(i).y
      P(i).z = (P(i).zo - CenterZ) : POnly(i).z = P(i).z
   Next i

   'get farthest point to use for setting scalefactor
   FarthestPoint = 0
   For i = 1 To UBound(P)
      sTemp = Sqr(P(i).x*P(i).x + P(i).y*P(i).y + P(i).z*P(i).z)
      If FarthestPoint < Abs(sTemp) Then FarthestPoint = Abs(sTemp)
   Next i
   Control Get Size hDlg, %IDC_Graphic To w,h
   If h < w Then ScaleFactor = h /(2*FarthestPoint)*0.9 Else ScaleFactor = w/(2*FarthestPoint)*0.9

   'scale points to fit within graphic control
   For i = 1 To UBound(P)
      P(i).x = P(i).x * ScaleFactor : POnly(i).x = P(i).x
      P(i).y = P(i).y * ScaleFactor : POnly(i).y = P(i).y
      P(i).z = P(i).z * ScaleFactor : POnly(i).z = P(i).z
   Next i
End Sub

Sub ScaleToFit1
   Local i,w,h As Long
   Local CenterX, CenterY, CenterZ, ScaleFactor, Ratio As Single

   CenterX = (XHigh + XLow)/2
   CenterY = (YHigh + YLow)/2
   CenterZ = (ZHigh + ZLow)/2

   Control Get Size hDlg, %IDC_Graphic To w,h

   'reduce size to fit within boundaries
   Ratio = Abs(XHigh / w * 2)
   If Ratio < Abs(YHigh / h * 2) Then Ratio = Abs(YHigh / h * 2)
   If Ratio < Abs(XLow / w * 2) Then Ratio = Abs(XLow / w * 2)
   If Ratio < Abs(YLow / h * 2) Then Ratio = Abs(YLow / h * 2)

   'move all nodes to center position
   For i = 1 To UBound(P)
      P(i).x = (P(i).xo - CenterX) / Ratio * 0.9 : POnly(i).x = P(i).x
      P(i).y = (P(i).yo - CenterY) / Ratio * 0.9 : POnly(i).y = P(i).y
      P(i).z = (P(i).zo - CenterZ) / Ratio * 0.9 : POnly(i).z = P(i).z
   Next i
End Sub

Sub ScaleToFit3
   Local i,w,h As Long, ScaleFactor As Single
   Control Get Size hDlg, %IDC_Graphic To w,h
   If h < w Then ScaleFactor = h /(2*FarthestPoint)*0.9 Else ScaleFactor = w/(2*FarthestPoint)*0.9
   For i = 1 To UBound(P)
      P(i).x = P(i).xo * ScaleFactor : POnly(i).x = P(i).x
      P(i).y = P(i).yo * ScaleFactor : POnly(i).y = P(i).y
      P(i).z = P(i).zo * ScaleFactor : POnly(i).z = P(i).z
   Next i
End Sub

Sub CreateEquation
   MousePtr 11
   Local w,h,iCount,TCount,xSteps,ySteps As Long, x,y As Single, Expr As String
   w = (Equations(CurrentEquationIndex).XMax - Equations(CurrentEquationIndex).XMin) / Equations(CurrentEquationIndex).XStep + 1
   h = (Equations(CurrentEquationIndex).YMax - Equations(CurrentEquationIndex).YMin) / Equations(CurrentEquationIndex).YStep + 1
   ReDim P(w*h), POnly(w*h), T((w-1)*(h-1)*2)

   For x = Equations(CurrentEquationIndex).XMin To Equations(CurrentEquationIndex).XMax Step Equations(CurrentEquationIndex).XStep
      Incr xSteps
      For y = Equations(CurrentEquationIndex).YMin To Equations(CurrentEquationIndex).YMax Step Equations(CurrentEquationIndex).YStep
         'points
         Incr iCount
         P(iCount).x = x                  : POnly(iCount).x = P(iCount).x : P(iCount).xo = P(iCount).x
         P(iCount).y = y                  : POnly(iCount).y = P(iCount).y : P(iCount).yo = P(iCount).y
            Expr = Equations(CurrentEquationIndex).Equa
            Replace "x" With "(" + Str$(x) + ")" In Expr
            Replace "y" With "(" + Str$(y) + ")" In Expr
         P(iCount).z = Evaluate(Expr)  : POnly(iCount).z = P(iCount).z : P(iCount).zo = P(iCOunt).z

         'triangles
         Incr ySteps
         If xSteps > 1 And ySteps < h Then
            Incr TCount
            T(TCount).p1 = (xSteps-1)*h + ySteps
            T(TCount).p2 = T(TCount).p1 - h + 1
            T(TCount).p3 = T(TCount).p1 - h
            Incr TCount
            T(TCount).p1 = (xSteps-1)*h + ySteps
            T(TCount).p2 = T(TCount).p1 + 1
            T(TCount).p3 = T(TCount).p2 - h
         End If
      Next y
      ySteps = 0
   Next x
   P(1).Marker = -1 : P(UBound(P)).Marker = 1
   SetPointGradientColors
   SetTriangleGradientColors
   CreateOriginalPTString
   MousePtr 0
End Sub

Sub CreateCube
   Local i As Long
   ReDim P(8), POnly(8), T(12)
   P(1).x = -50  : P(1).y = -50  : P(1).z = -50
   P(2).x = -50  : P(2).y =  50  : P(2).z = -50
   P(3).x =  50  : P(3).y =  50  : P(3).z = -50
   P(4).x =  50  : P(4).y = -50  : P(4).z = -50
   P(5).x = -50  : P(5).y = -50  : P(5).z =  50
   P(6).x = -50  : P(6).y =  50  : P(6).z =  50
   P(7).x =  50  : P(7).y =  50  : P(7).z =  50
   P(8).x =  50  : P(8).y = -50  : P(8).z =  50
   T(1).p1 = 1 : T(1).p2 = 4 : T(1).p3 = 3
   T(2).p1 = 1 : T(2).p2 = 3 : T(2).p3 = 2
   T(3).p1 = 5 : T(3).p2 = 1 : T(3).p3 = 2
   T(4).p1 = 5 : T(4).p2 = 2 : T(4).p3 = 6
   T(5).p1 = 8 : T(5).p2 = 5 : T(5).p3 = 6
   T(6).p1 = 8 : T(6).p2 = 6 : T(6).p3 = 7
   T(7).p1 = 4 : T(7).p2 = 8 : T(7).p3 = 7
   T(8).p1 = 4 : T(8).p2 = 7 : T(8).p3 = 3
   T(9).p1 = 3 : T(9).p2 = 7 : T(9).p3 = 6
   T(10).p1 = 3 : T(10).p2 = 6 : T(10).p3 = 2
   T(11).p1 = 4 : T(11).p2 = 1 : T(11).p3 = 5
   T(12).p1 = 4 : T(12).p2 = 5 : T(12).p3 = 8

    For i = 1 To UBound(P)
       P(i).xo = P(i).x : POnly(i).x = P(i).x
       P(i).yo = P(i).y : POnly(i).y = P(i).y
       P(i).zo = P(i).z : POnly(i).z = P(i).z
    Next i
   P(1).Marker = -1 : P(UBound(P)).Marker = 1
   SetPointGradientColors
   SetTriangleGradientColors
   CreateOriginalPTString
End Sub

Sub CreateSphere()
   Local i, j, iCount, TCount, iLayers, iDivisions  As Long
   Local SAngle, Radius, z, zStep, tempS As Single
   iLayers = 20 : iDivisions = 20 : Radius = 100 : iCount = 1
   ReDim P(iLayers * iDivisions + 2)    'position P(0) is reserved
   ReDim POnly(iLayers * iDivisions + 2)    'position P(0) is reserved
   ReDim T((iLayers-1)*iDivisions*2 + 4*iDivisions)

   SAngle = 6.28 / iDivisions   '1 radian = 57.2957 degrees : 1 degree = 0.0174532 radians
   zStep = 2 * Radius / (iLayers+1)

   'Points
   P(iCount).x = 0 : P(iCount).y = 0 : P(iCount).z = Radius
   P(UBound(P)).x = 0 : P(UBound(P)).y = 0 : P(UBound(P)).z = -1 * Radius
   For i = 1 To iLayers
      z = Radius - zStep * i
      tempS = Sqr(Radius*Radius - z*z)
      For j = 0 To iDivisions - 1
         iCount = iCount + 1
         P(iCount).x = tempS * Sin(j*SAngle)
         P(iCount).y = tempS * Cos(j*SAngle)
         P(iCount).z = z
      Next j
   Next i

   For i = 1 To UBound(P)
      P(i).xo = P(i).x : POnly(i).x = P(i).x
      P(i).yo = P(i).y : POnly(i).y = P(i).y
      P(i).zo = P(i).z : POnly(i).z = P(i).z
   Next i

   'triangles
   'top layer
   For i = 2 To iDivisions
      Incr TCount  :   T(TCount).p1 = 1  :  T(TCount).p2 = i+1 :  T(TCount).p3 = i
   Next i
   Incr TCount  :   T(TCount).p1 = 1  :  T(TCount).p2 = 2 :  T(TCount).p3 = iDivisions + 1

   'bottom layer
   For i = UBound(P)-iDivisions To UBound(P)-1
      Incr TCount  :   T(TCount).p1 = UBound(P) :  T(TCount).p2 = i :  T(TCount).p3 = i+1
   Next i
   Incr TCount  :   T(TCount).p1 = UBound(P)  :  T(TCount).p2 = UBound(P)-1 :  T(TCount).p3 = UBound(P)-iDivisions

   'other layers
   For i = 1 To iLayers-1
      iCount = (i-1)*iDivisions + 1
      'most divisions
      For j = 1 To iDivisions -1
         Incr TCount
         T(TCount).p1 = j + iCount
         T(TCount).p2 = T(TCount).p1 + iDivisions + 1
         T(TCount).p3 = T(TCount).p1 + iDivisions
         Incr TCount
         T(TCount).p1 = j + iCount
         T(TCount).p2 = T(TCount).p1 + 1
         T(TCount).p3 = T(TCount).p1 + iDivisions + 1
      Next j
      'last division
      Incr TCount
      T(TCount).p1 = iDivisions + iCount
      T(TCount).p2 = 1 + iCount + iDivisions
      T(TCount).p3 = iCount + iDivisions + iDivisions
      Incr TCount
      T(TCount).p1 = iDivisions + iCount
      T(TCount).p2 = 1 + iCount
      T(TCount).p3 = 1 + iCount + iDivisions
   Next i
   P(1).Marker = -1 : P(UBound(P)).Marker = 1
   SetPointGradientColors
   SetTriangleGradientColors
   CreateOriginalPTString
End Sub


Function GetColor(startColor As Long) As Long
   Local ColorResult&
   Display Color hDlg, 100, 100, startColor, CustomColorList, 0 To ColorResult&
   If ColorResult& = -1 Then
      Function = startColor    'startColor is returned if Cancel/Escape is pressed
   Else
      Function = ColorResult&    'used SelectedColor& as firstcolor the next time the dialog is displayed
   End If
End Function

Sub DisplayInfo

    If DataDisplay = 0 Then Exit Sub

    Local temp As String
    temp =                "Model: " + Choose$(ModelType,"Cube","Sphere","<equation>" + $CrLf + Trim$(Equations(CurrentEquationIndex).Equa),"<file>" + $CrLf + PathName$(Namex,CurrentFileName))
    temp = temp + $CrLf + $CrLf + "Points: " + Str$(UBound(P))
    temp = temp + $CrLf + "Triangles: " + Str$(UBound(T))
    temp = temp + $CrLf
    temp = temp + $CrLf + "Display Mode: " + Choose$(DisplayType,"Point","Line","Surfaces")

    temp = temp + $CrLf
    temp = temp + $CrLf + "Backface Cullt: " + IIf$(Backface,"On","Off")
    temp = temp + $CrLf + "Depth Sort: " + IIf$(DepthSort,"On","Off")
    temp = temp + $CrLf + "Projection: " + IIf$(Projection,"On","Off")

    temp = temp + $CrLf
    temp = temp + $CrLf + "Gradient: " + IIf$(Gradient,"On","Off")
    temp = temp + $CrLf + "Markers: " + IIf$(Markers,"On","Off")

    temp = temp + $CrLf
    temp = temp + $CrLf + "Speed: " + Str$(Speed)
    temp = temp + $CrLf + "Angle: " + Str$(Angle)
    temp = temp + $CrLf + "Point Size: " + Str$(PointSize)

    Control Set Text hDlg, %IDC_TextBox, temp + $CrLf + $CrLf + OriginalPT
End Sub

Sub CreateOriginalPTString
    Local i As Long
    OriginalPT = "Points:"         'OriginalPT + $CrLf + $CrLf + "Points:"
    For i = 1 To UBound(P)
       OriginalPT = OriginalPT + $CrLf + Format$(P(i).x,"00") + Format$(P(i).y," 00") + Format$(P(i).z," 00")
    Next i
   OriginalPT = OriginalPT + $CrLf + $CrLf + "Triangles:"
    For i = 1 To UBound(T)
       OriginalPT = OriginalPT + $CrLf + Str$(T(i).p1) + Str$(T(i).p2) + Str$(T(i).p3)
    Next i
End Sub

Sub SetTriangleGradientColors
   Local i As Long
   If UBound(T) < 1 Then THigh = 0: TLow = 0 : Exit Sub
   SetTriangleHighLow
   If UBound(T) > 0 Then
      For i = 1 To UBound(T)
         T(i).ColorG = GradientZ(T(i).ZDepthO, THigh, TLow)
      Next i
   End If
End Sub

Sub SetPointGradientColors
   Local i As Long
   SetPointHighLow
   For i = 1 To UBound(P)
      P(i).ColorG = GradientZ(P(i).zo, ZHigh, ZLow) :  POnly(i).ColorG = P(i).ColorG
   Next i
End Sub

Function GradientZ(ZValue As Single, HiZ As Single, LoZ As Single) As Long
   'returns Long color, and RGB components, across the entire spectrum based on position of a number between two limits
   Local CRatio As Single, Exponent As Single
   Local R,G,B As Long
   Exponent = 0.365
   If HiZ <> LoZ Then
       CRatio = Abs((ZValue - LoZ) / (HiZ - LoZ))
   Else
       CRatio = 0
   End If

   If CRatio > 1 Then CRatio = 1
   If CRatio < 0 Then CRatio = 0

   Select Case CRatio
       Case Is < 0.25
           r = 0
           g = 255 * (((CRatio - 0) * 4) ^ Exponent)
           b = 255
       Case Is < 0.5
           r = 0
           g = 255
           b = 255 * ((1 - (CRatio - 0.25) * 4) ^ Exponent)
       Case Is < 0.75
           r = 255 * (((CRatio - 0.5) * 4) ^ Exponent)
           g = 255
           b = 0
       Case Else
           r = 255
           g = 255 * ((1 - (CRatio - 0.75) * 4) ^ Exponent)
           b = 0

   End Select
   Function = RGB(r, g, b)

End Function

Sub CycleSpeed
   Select Case Speed
      Case 1 : Speed = 2
      Case 2 : Speed = 5
      Case 5 : Speed = 10
      Case 10 : Speed = 20
      Case 20 : Speed = 40
      Case 40 : Speed = 60
      Case 60 : Speed = 80
      Case 80 : Speed = 100
      Case 100 : Speed = 250
      Case 250 : Speed = 500
      Case 500 : Speed = 1
   End Select
End Sub

Sub CyclePointSize
   Select Case Pointsize
      Case 1  : PointSize = 2
      Case 2  : PointSize = 3
      Case 3  : PointSize = 4
      Case 4  : PointSize = 5
      Case 5  : PointSize = 10
      Case 10 : PointSize = 25
      Case 25 : PointSize = 50
      Case 50 : PointSize = 1
   End Select
End Sub

Sub CycleModel
   Select Case ModelType
      Case 1
         ModelType = 2  : CreateSphere
      Case 2
         ModelType = 3  : CreateEquation
      Case 3
         If IsFile(CurrentFileName) Then
            ModelType = 4
            LoadObjectFromFile CurrentFileName
         Else
            ModelType = 1 : CreateCube
         End If
      Case 4
         ModelType = 1  : CreateCube
   End Select
End Sub

Sub CycleAngle
   Select Case Angle
      Case 0.01 : Angle = 0.02
      Case 0.02 : Angle = 0.03
      Case 0.03 : Angle = 0.04
      Case 0.04 : Angle = 0.05
      Case 0.05 : Angle = 0.10
      Case 0.10 : Angle = 0.20
      Case 0.20 : Angle = 0.01
   End Select
End Sub

Sub CycleColors
    Static ColorSelection As Long
    Select Case ColorSelection
       Case 0 : BColor = %rgb_Maroon
       Case 1 : BColor = %rgb_DarkGreen
       Case 2 : BColor = %rgb_DarkBlue
       Case 3 : BColor = %rgb_DimGray
       Case 4 : BColor = %Black
       Case 5 : BColor = %White
       Case 6 : BColor = BackColor
    End Select
    ColorSelection = ColorSelection + 1
    If ColorSelection > 6 Then Colorselection = 0
End Sub

Sub CycleEquations
    Incr CurrentEquationIndex
    If CurrentEquationIndex > UBound(Equations) Then CurrentEquationIndex = 0
    CreateEquation
    ScaleToFit : ShortPipeLine : DisplayInfo
End Sub

Function Evaluate(ByVal pExpression As String) As Single
    Local lExpression As String
    lExpression = PrepExpNum(pExpression)      ' PREPare the NUMerical EXPexpression before the evaluation
    Function = EvalExpNum(lExpression)
End Function

Function PrepExpNum(ByRef pExpression As String) As String
    Local lNewExpression As String
    lNewExpression = UCase$(Trim$(pExpression))
    Replace "LOG10" With "LOGTEN"  In lNewExpression
    Replace "LOG2"  With "LOGTWO"  In lNewExpression
    Replace "EXP10" With "EXPTEN"  In lNewExpression
    Replace "EXP2"  With "EXPTWO"  In lNewExpression
    Replace "PI"    With "3.14159" In lNewExpression
    Replace "-"     With "_"       In lNewExpression  ' to avoid any confusion with a negative value
    Function = lNewExpression
End Function

Function EvalExpNum(ByVal pExpression As String) As Single      'Extended
'Credit: Jean-Pierre Leroy (Jan, 2010)
    Local    lOpenParentheseStart, lOpenParentheseCounter, lCloseParentheseCounter As Long
    Local    lCurrentPos, lI, lPosOperator, lLeftOperandStart As Long
    Local    lleftOperandEnd, lRightOperandStart, lRightOperandEnd As Long
    Local    lEval, lLeftOperand, lRightOperand As Single         'Extended

    Do
        lOpenParentheseCounter  = 0 : lCloseParentheseCounter = 0   'reset the parentheses counters
        lOpenParentheseStart = InStr(pExpression, "(")              'search for a open parenthese "(" in the expression
        If lOpenParentheseStart <> 0 Then                           'only if we find a open parenthese "(" in the expression
            lOpenParentheseCounter = 1                              'initialize the open parenthese counter to 1
            lCurrentPos = lOpenParentheseStart                      'we start at the open parenthese
            Do
                Incr lCurrentPos                                    'increment the current position
                If Mid$(pExpression, lCurrentPos, 1) = ")" Then Incr lCloseParentheseCounter    ' to count the number of parentheses
                If Mid$(pExpression, lCurrentPos, 1) = "(" Then Incr lOpenParentheseCounter
            Loop Until lOpenParentheseCounter = lCloseParentheseCounter

            pExpression = Left$(pExpression,lOpenParentheseStart-1)+ _    'recursive call to EvalExpNum
                          Format$(EvalExpNum(Mid$(pExpression,lOpenParentheseStart+1,lCurrentPos-lOpenParentheseStart-1)))+ _
                          Right$(pExpression,-lCurrentPos)
        Else
            Data "ATN", "COS", "SIN", "TAN", "LOGTEN", "LOGTWO", "LOG", "EXPTEN"
            Data "EXPTWO", "EXP", "SQR", "ABS", "^", "*", "/", "\", "MOD", "_", "+"
            For lI = 1 To DataCount                ' check all the Operators/Functions that could be used in the numerical expression
                 Do                                ' examines all the occurences of the operator/function
                     lPosOperator = InStr(pExpression,Read$(lI))
                     If lPosOperator <> 0 Then               ' only if we find the Operator/Function
                         lLeftOperandEnd = lPosOperator-1    ' search the start/end of the left operand
                         lCurrentPos     = lPosOperator
                         Do
                            Decr lCurrentPos                     ' decrement current pos
                            If   lCurrentPos < 1 Then Exit Loop  ' if we are out of the string
                        Loop Until InStr(" 0123456789.-",Mid$(pExpression, lCurrentPos, 1)) = 0
                        lLeftOperandStart = lCurrentPos+1

                        lRightOperandStart = lPosOperator+Len(Read$(lI))    ' search the start/end of the right operand
                        lCurrentPos          = lPosOperator+Len(Read$(lI))-1
                        Do
                            Incr lCurrentPos                                     ' decrement current pos
                            If   lCurrentPos > Len(pExpression) Then Exit Loop   ' if we are out of the string
                        Loop Until InStr(" 0123456789.-",Mid$(pExpression, lCurrentPos, 1)) = 0
                        lRightOperandEnd = lCurrentPos - 1

                        lLeftOperand  = Val(Trim$(Mid$(pExpression,lLeftOperandStart ,lLeftOperandEnd -lLeftOperandStart +1))) ' extract the operands removing spaces
                        lRightOperand = Val(Trim$(Mid$(pExpression,lRightOperandStart,lRightOperandEnd-lRightOperandStart+1))) ' extract the operands removing spaces

                        Select Case Read$(lI)                     ' depending of the Operator/Function
                            Case "ATN"     :  lEval = Atn(lRightOperand)
                            Case "COS"     :  lEval = Cos(lRightOperand)
                            Case "SIN"     :  lEval = Sin(lRightOperand)
                            Case "TAN"     :  lEval = Tan(lRightOperand)
                            Case "LOGTEN"  :  lEval = Log10(lRightOperand)
                            Case "LOGTWO"  :  lEval = Log2(lRightOperand)
                            Case "LOG"     :  lEval = Log(lRightOperand)
                            Case "EXPTEN"  :  lEval = Exp10(lRightOperand)
                            Case "EXPTWO"  :  lEval = Exp2(lRightOperand)
                            Case "EXP"     :  lEval = Exp(lRightOperand)
                            Case "SQR"     :  lEval = Sqr(lRightOperand)
                            Case "ABS"     :  lEval = Abs(lRightOperand)
                            Case "^"       :  lEval = lLeftOperand ^ lRightOperand
                            Case "*"       :  lEval = lLeftOperand * lRightOperand
                            Case "/"       :  lEval = lLeftOperand / lRightOperand
                            Case "\"       :  lEval = lLeftOperand \ lRightOperand
                            Case "MOD"     :  lEval = lLeftOperand Mod lRightOperand
                            Case "_"       :  lEval = lLeftOperand - lRightOperand
                            Case "+"       :  lEval = lLeftOperand + lRightOperand
                        End Select
                        lEval = Round(lEval, 2)  'round the evaluation to 6 decimal places to avoid scientific notation (E-)
                        pExpression = Left$(pExpression,lLeftOperandStart-1)+Format$(lEval)+Right$(pExpression,-lRightOperandEnd) 'place the result of the evaluation in the string
                    End If
                 Loop Until lPosOperator = 0
             Next lI
            Function = Val(pExpression)  'to evaluate the final expression
        End If
    Loop Until lOpenParentheseStart = 0

End Function

Function SelectFileToOpen() As String
   Local filter$, startfile$, startfolder$
   Local defaultext$, flags&, filevar$, countvar&
   filter$ = Chr$("3D Files",0,"*.tov;*.stla;*.stlb",0)
'   filter$ = Chr$("TOV Files", 0, "*.tov", 0, "STL-Ascii", 0, "*.stla", 0, "STL-Binary", 0, "*.stlb", 0)
   startfolder$ = CurrentFileName     'initial folder to be displayed
   startfile$ = CurrentFileName       'name to be used as initial selection
   defaultext$ = "txt"                 'default extension to append to selection if user does not enter it
   flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
   Display Openfile hDlg, 100, 100, "", startfolder$, filter$, startfile$, _
   defaultext$, flags& To filevar$, countvar&
   If IsFile(filevar$) Then Function = filevar$
End Function

Sub LoadEquationList
   If Len(Dir$("equations.txt"))=0 Then   'equation file is missing
       ReDim Equations(0)
       Equations(0).Equa = "sin(sqr(x*x+y*y))"
       Equations(0).Title = "File Missing - Default Equation Loaded"
       Equations(0).XMax = 30 : Equations(0).XMax = -30 : Equations(0).XStep = 1
       Equations(0).YMax = 30 : Equations(0).YMax = -30 : Equations(0).YStep = 1
       Exit Sub
   End If

   Local i As Long, temp As String
   Open "equations.txt" For Input As #1
   While IsFalse(Eof(1))
      ReDim Preserve Equations(i)
      Line Input #1, Equations(i).Equa
      Line Input #1, Equations(i).Title

      Line Input #1, temp
      temp = Trim$(temp)
      While InStr(temp, "  ") : Replace "  " With " " In temp : Wend   'remove extra spaces
      Equations(i).XMax  = Val(Parse$(temp," ",1))
      Equations(i).XMin  = Val(Parse$(temp," ",2))
      Equations(i).XStep = Val(Parse$(temp," ",3))

      Line Input #1, temp
      temp = Trim$(temp)
      While InStr(temp, "  ") : Replace "  " With " " In temp : Wend   'remove extra spaces
      Equations(i).YMax  = Val(Parse$(temp," ",1))
      Equations(i).YMin  = Val(Parse$(temp," ",2))
      Equations(i).YStep = Val(Parse$(temp," ",3))

      Line Input #1, temp                              ' ----
      Incr i
   Wend
   Close #1
End Sub

Sub BuildLeftSide
   Local w,h As Long

   SendMessage(hDlg, %WM_SETREDRAW, 0, 0)  'Turn off redraw for faster and smoother action
   'start over - kill all controls
   Control Kill hDlg, 700            'progress bar
   KillEquationControls              'equation controls
   Control Kill hDlg, %IDC_TextBox   'textbox

   If DataDisplay Then
      Dialog Get Client hDlg To w,h
      If ModelType = 3 Then
         AddProgressBar
         Control Add TextBox, hDlg, %IDC_TextBox, "", 10,210,175,h-240, TextBoxStyle
         AddEquationControls
         SetEquationControlValues
      Else
         AddProgressBar
         Control Add TextBox, hDlg, %IDC_TextBox, "", 10,110,175,h-140, TextBoxStyle
      End If
   End If

   SendMessage hDlg, %WM_SETREDRAW, 1, 0   'Turn on redraw again and refresh
   Dialog ReDraw hDlg

End Sub

Sub KillEquationControls
   Control Kill hDlg, %IDC_Equation
   Control Kill hDlg, %IDC_Title
   Control Kill hDlg, %IDC_XMax
   Control Kill hDlg, %IDC_XMin
   Control Kill hDlg, %IDC_XStep
   Control Kill hDlg, %IDC_YMax
   Control Kill hDlg, %IDC_YMin
   Control Kill hDlg, %IDC_YStep
End Sub

Sub AddEquationControls
   Control Add TextBox, hDlg, %IDC_Equation, "", 10,110,170,20
   Control Add TextBox, hDlg, %IDC_Title   , "", 10,135,170,20
   Control Add TextBox, hDlg, %IDC_XMax    , "", 10,160,50,20
   Control Add TextBox, hDlg, %IDC_XMin    , "", 70,160,50,20
   Control Add TextBox, hDlg, %IDC_XStep   , "", 130,160,50,20
   Control Add TextBox, hDlg, %IDC_YMax    , "", 10,185,50,20
   Control Add TextBox, hDlg, %IDC_YMin    , "", 70,185,50,20
   Control Add TextBox, hDlg, %IDC_YStep   , "", 130,185,50,20
End Sub

Sub SetEquationControlValues
   Control Set Text hDlg, %IDC_Equation, Trim$(Equations(CurrentEquationIndex).Equa)
   Control Set Text hDlg, %IDC_Title,    Trim$(Equations(CurrentEquationIndex).Title)
   Control Set Text hDlg, %IDC_XMax    , Str$(Equations(CurrentEquationIndex).XMax)
   Control Set Text hDlg, %IDC_XMin    , Str$(Equations(CurrentEquationIndex).Xmin)
   Control Set Text hDlg, %IDC_XStep   , Str$(Equations(CurrentEquationIndex).XStep)
   Control Set Text hDlg, %IDC_YMax    , Str$(Equations(CurrentEquationIndex).YMax)
   Control Set Text hDlg, %IDC_YMin    , Str$(Equations(CurrentEquationIndex).YMin)
   Control Set Text hDlg, %IDC_YStep   , Str$(Equations(CurrentEquationIndex).YStep)
End Sub

Sub DeleteEquation
    'do not remove last equation
    If UBound(Equations) = 0 Then
        MsgBox "Cannot delete last equation!", %MB_Ok, "Delete Equation"
        Exit Sub
    End If

    'remove all
    Local i As Long
    For i = 0 To UBound(Equations)
       Menu Delete hPopup6, 1
    Next i

    'remove current equation from array
    Array Delete Equations(CurrentEquationIndex)
    ReDim Preserve Equations(UBound(Equations)-1)
    If CurrentEquationIndex > UBound(Equations) Then CurrentEquationIndex = UBound(Equations)

    'rebuild
    CreateDropDownEquationList
    SetEquationControlValues
End Sub

Sub NewEquation
   Local i As Long
   i = UBound(Equations) + 1
   ReDim Preserve Equations(i)
   Equations(i) = Equations(CurrentEquationIndex)
   Equations(i).Title = "New Equation"
   DisplayType = 3
   CurrentEquationIndex = i
   SetEquationControlValues
   Menu Add String, hPopup6, Trim$(Equations(i).Equa), 600+i, %MF_Enabled
End Sub

Sub ModifyCurrentEquation
   If ModelType <> 3 Then Exit Sub
   Local i As Long, temp As String
   i = CurrentEquationIndex
   Control Get Text hDlg, %IDC_Equation To Equations(i).Equa
   Control Get Text hDlg, %IDC_Title    To Equations(i).Title
   Control Get Text hDlg, %IDC_XMax     To temp : Equations(i).XMax = Val(temp)
   Control Get Text hDlg, %IDC_XMin     To temp : Equations(i).XMin = Val(temp)
   Control Get Text hDlg, %IDC_XStep    To temp : Equations(i).XStep = Val(temp)
   Control Get Text hDlg, %IDC_YMax     To temp : Equations(i).YMax = Val(temp)
   Control Get Text hDlg, %IDC_YMin     To temp : Equations(i).YMin = Val(temp)
   Control Get Text hDlg, %IDC_YStep    To temp : Equations(i).YStep = Val(temp)
   CurrentEquationIndex = i
End Sub

Sub SaveEquationsToFile
   Local i As Long
   Open "equations.txt" For Output As #1
   For i = 0 To UBound(Equations)
      Print #1, Equations(i).Equa
      Print #1, Equations(i).Title
      Print #1, Str$(Equations(i).Xmax) + " " + Str$(Equations(i).Xmin) + " " + Str$(Equations(i).XStep)
      Print #1, Str$(Equations(i).Ymax) + " " + Str$(Equations(i).YMin) + " " + Str$(Equations(i).YStep)
      Print #1, "----"
   Next i
   Close #1
End Sub

Sub DisplayHelp
   Local temp As String
   temp = "Graphic Laboratory"
   temp = temp + $CrLf + "     Built-in cube and sphere models"
   temp = temp + $CrLf + "     TOV Files (point coordinates, triangle vertices)"
   temp = temp + $CrLf + "     Stereolithography (STL) Files (Ascii and Binary)"
   temp = temp + $CrLf + "     Equations of the form z = f(x,y)"

   temp = temp + $CrLf + $CrLf + "Display:"
   temp = temp + $CrLf + "     3D Pipeline: rotation, backface culling, depth sorting, and projection"
   temp = temp + $CrLf + "     Points, lines, and surfaces (triangles)"
   temp = temp + $CrLf + "     Rotate automatically, single-step or using mouse"
   temp = temp + $CrLf + "     XYZ rotation set independently"
   temp = temp + $CrLf + "     Reset, zoom and pan options"
   temp = temp + $CrLf + "     Control speed, rotation angle, point size, colors"
   temp = temp + $CrLf + "     Gradient colors based point/surface-center z-coordinates"

   temp = temp + $CrLf + $CrLf + "Built-In Models:"
   temp = temp + $CrLf + "     Cube and sphere models built-in"

   temp = temp + $CrLf + $CrLf + "Files:"
   temp = temp + $CrLf + "     Reads TOV/STLA/STLB file types"

   temp = temp + $CrLf + $CrLf + "Equations:"
   temp = temp + $CrLf + "     Dropdown equation list is read from 'equations.txt'"
   temp = temp + $CrLf + "     New/Delete/Modify/Save equation options are provided"
   temp = temp + $CrLf + "     New creates duplicate of current equation"
   temp = temp + $CrLf + "     Plot paramenters are: XMax, XMin, XStep and then YMax, YMin, YStep"
   temp = temp + $CrLf + $CrLf


   MsgBox temp, %MB_Ok, "gbPoints - 3D Graphics Laboratory"
End Sub

Sub MoveUp
    Local i As Long
    For i = 1 To UBound(P)
        P(i).y = P(i).y - 25 : POnly(i).y = P(i).y
    Next i
End Sub

Sub MoveDown
    Local i As Long
    For i = 1 To UBound(P)
        P(i).y = P(i).y + 25 : POnly(i).y = P(i).y
    Next i
End Sub

Sub MoveLeft
    Local i As Long
    For i = 1 To UBound(P)
        P(i).x = P(i).x - 25 : POnly(i).x = P(i).x
    Next i
End Sub

Sub MoveRight
    Local i As Long
    For i = 1 To UBound(P)
        P(i).x = P(i).x + 25 : POnly(i).x = P(i).x
    Next i
End Sub

Sub ChangeSize (Flag As Long)
    Local i As Long, Factor As Single
    Factor = (1 + 0.2 * Flag)
    For i = 1 To UBound(P)
        P(i).x = P(i).x * Factor : POnly(i).x = P(i).x
        P(i).y = P(i).y * Factor : POnly(i).y = P(i).y
        P(i).z = P(i).z * Factor : POnly(i).z = P(i).z
    Next i
End Sub

Sub AddMenu()
   Menu New Bar To hMenu
   Menu New PopUp To hMenuFile
   Menu Add PopUp, hMenu, "&File", hMenuFile, %MF_Enabled
'      Menu Add String, hMenuFile, "&Export As STL", %IDM_FileExportSTL, %MF_Enabled
'      Menu Add String, hMenuFile, "&Export As TOV", %IDM_FileExportTOV, %MF_Enabled
      Menu Add String, hMenuFile, "E&xit"         , %IDM_FileExit, %MF_Enabled
   Menu Attach hMenu, hDlg
End Sub

Sub ExportAsSTL
    MsgBox "STL export not implemented!", %MB_Ok, "gbPoints - 3D Laboratory"
End Sub

Sub ExportAsTOV
    MsgBox "TOV export not implemented!", %MB_Ok, "gbPoints - 3D Laboratory"
End Sub
